package cc.smtweb.system.bpm.web.engine.flow;

import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractCompService;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageDelHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageLoadHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageSaveHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageService;

/**
 * Created by Akmm at 2022/5/24 14:21
 * 工作流
 */
public class FlowService extends DynPageService {
    public final static String TYPE_FLOW = "flow";

    @Override
    protected AbstractHandler createHandler(String type) {
        switch (type) {
            case TYPE_LOAD:
                return new DynPageLoadHandler();
            case TYPE_SAVE:
                return new DynPageSaveHandler();
            case TYPE_DEL:
                return new DynPageDelHandler();
        }
        return null;
    }

    protected R flowHandler(SwMap params, UserSession us, IFlowWorker worker) {
        try {
            FlowHandler handler = (FlowHandler)getHandler(params, us, TYPE_FLOW);
            return worker.doWork(handler);
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    /**
     * 办理，签收
     *
     * @throws Exception
     */
    public void handle(@SwBody SwMap params, UserSession us) {
        flowHandler(params, us, FlowHandler::handle);
    }

    /**
     * 提交
     *
     * @throws Exception
     */
    public void submit(@SwBody SwMap params, UserSession us) {
        flowHandler(params, us, FlowHandler::handle);
    }


    /**
     * 提交
     *
     * @throws Exception
     */
    public void checkSubmit(@SwBody SwMap params, UserSession us) {

    }


    /**
     * 作废
     *
     * @throws Exception
     */
    public void disuse(@SwBody SwMap params, UserSession us) {

    }


    /**
     * 取消提交
     *
     * @throws Exception
     */
    public void retake(@SwBody SwMap params, UserSession us) {

    }

    /**
     * 驳回
     *
     * @throws Exception
     */
    public void reject(@SwBody SwMap params, UserSession us) {

    }


    public void rejectToMake(@SwBody SwMap params, UserSession us) {

    }

    interface IFlowWorker {
        R doWork(FlowHandler handler);
    }
}
